#!/usr/bin/env python

from xml.sax.saxutils import XMLGenerator
from xml.sax.xmlreader import AttributesNSImpl

class SavePreferences:
    def __init__(self, OutFile, Encoding):
        """
        Set up a logger object, which takes SAX events and outputs
        an XML log file
        """
        saver = XMLGenerator(OutFile, Encoding)
        saver.startDocument()
        attrs = AttributesNSImpl({}, {})
        saver.startElementNS((None, u'winedoors'), u'winedoors', attrs)
        self._saver = saver
        self._OutFile = OutFile
        self._Encoding = Encoding
        return

    def write_entry(self, TagName, TagValue, RepoUri):
        if TagName == "repo":
            attr_vals = {
                (None, u'uri'): RepoUri
            }
            attr_qnames = {
                (None, u'uri'): u'uri',
                }
            attrs = AttributesNSImpl(attr_vals, attr_qnames)
            TagText = unicode(TagName)
            self._saver.startElementNS((None, TagText), TagText, attrs)
            self._saver.characters(TagValue)
            self._saver.endElementNS((None, TagText), TagText)
        else: 
            attr_vals = {}              
            attr_qnames = {}
            attrs = AttributesNSImpl(attr_vals, attr_qnames)
            TagText = unicode(TagName)
            self._saver.startElementNS((None, TagText), TagText, attrs)
            self._saver.characters(TagValue)
            self._saver.endElementNS((None, TagText), TagText)
            return

    def close(self):
        """
        Clean up the logger object
        """
        self._saver.endElementNS((None, u'winedoors'), u'winedoors')
        self._saver.endDocument()
        return

if __name__ == "__main__":
    #Test it out
    import sys
    xl = SavePreferences(sys.stdout, 'utf-8')
    xl.write_entry(u'name', u'Alex',u'none')
    xl.close()  